-- K_GlanceAtPlayers reworked for SRB2Kart
local FRACBITS = FRACBITS

-- K_GetKartGameSpeedScalar, ripped straight from DRRR
local function K_GetKartGameSpeedScalar(value)
    -- 4th Gear doesn't exist in SRB2Kart

	return ((13 + (3*value)) << FRACBITS) / 16
end

-- Why calculate if we can not calculate
local GAMESPEEDSCALARS = {}

for i = 0, 2 do
	GAMESPEEDSCALARS[i] = K_GetKartGameSpeedScalar(i)
end

rawset(_G, "K_GlanceAtPlayers", function(glancePlayer)
	local maxdistance = FixedMul(1280 * mapobjectscale, GAMESPEEDSCALARS[gamespeed])
	local blindSpotSize = ANG10 -- ANG5
	local glanceDir = 0
	local lastValidGlance = 0
	
	-- See if there's any players coming up behind us.
	-- If so, your character will glance at 'em.
	--local victim = nil

	for p in players.iterate do
		local back
		local diff
		local distance
		local dir = -1

		if p == glancePlayer then
			-- FOOL! Don't glance at yerself!
			continue
		end

		if p.spectator or p.kartstuff[k_hyudorotimer] > 0 then
			-- Not playing / invisible
			continue
		end

		if not p.mo then
			-- Object doesn't exist
			continue
		end

		distance = R_PointToDist2(glancePlayer.mo.x, glancePlayer.mo.y, p.mo.x, p.mo.y)
		distance = R_PointToDist2(0, glancePlayer.mo.z, distance, p.mo.z)

		if distance > maxdistance then
			-- Too far away
			continue
        end

		back = glancePlayer.mo.angle + ANGLE_180
		diff = R_PointToAngle2(glancePlayer.mo.x, glancePlayer.mo.y, p.mo.x, p.mo.y) - back
		local sdiff = (diff >> 16)

		if sdiff > (ANGLE_180 >> 16) then
			diff = InvAngle(diff)
			sdiff = (diff >> 16)
			
			dir = -dir
        end

		if sdiff > (ANGLE_90 >> 16) then
			-- Not behind the player
			continue
        end
		
		-- exploiting BLUA making bitshifts unsigned here
		if sdiff < (blindSpotSize >> 16) then
			-- Small blindspot directly behind your back, gives the impression of smoothly turning.
			continue
        end

        --victim = p.mo

		--CheckSight breaks on slope height differences in this piece of shit game - Onyo
		--if (P_CheckSight(glancePlayer.mo, victim) == false)
		--then
			-- Blocked by a wall, we can't glance at 'em!
			--continue
        --end

		-- Adds, so that if there's more targets on one of your sides, it'll glance on that side.
		glanceDir = $ + dir

		-- That poses a limitation if there's an equal number of targets on both sides...
		-- In that case, we'll pick the last chosen glance direction.
		lastValidGlance = dir
	end

	if glanceDir > 0 then
		return 1
	elseif glanceDir < 0 then
		return -1
    end

	return lastValidGlance
end)